#include <acknex.h>
#include <default.c>
#include <ackphysX.h>


#define PRAGMA_BIND "Brett4.mdl"; 
#define PRAGMA_BIND "Brett6.mdl"; 
#define PRAGMA_BIND "Brett8.mdl"; 
#define PRAGMA_BIND "Brett4.wmb"; 
#define PRAGMA_BIND "Brett6.wmb"; 
#define PRAGMA_BIND "Brett8.wmb"; 

#define PRAGMA_BIND "Pin4.mdl"; 
#define PRAGMA_BIND "Pin6.mdl"; 
#define PRAGMA_BIND "Pin8.mdl"; 

#define PRAGMA_BIND "dice.mdl"; 

#define PRAGMA_BIND "bar.tga"; 
#define PRAGMA_BIND "Hbar.tga"; 
#define PRAGMA_BIND "down.tga"; 
#define PRAGMA_BIND "okay.tga"; 
#define PRAGMA_BIND "radiobutton_off.tga"; 
#define PRAGMA_BIND "radiobutton_on.tga"; 
#define PRAGMA_BIND "radiobutton_over.tga"; 
#define PRAGMA_BIND "up.tga"; 
#define PRAGMA_BIND "dice.tga"; 
#define PRAGMA_BIND "mOn.tga"; 
#define PRAGMA_BIND "mOff.tga"; 

#define PRAGMA_BIND "Danger Storm.ogg"; 


//MODIFIERS
var showDebug=0;
var useWaits=0;


//DEFINES
#define STATUS skill11  //0: on Startfield; 1: on Gamefield; 2: on Endfield;
#define NODE skill12
#define STEPS skill13


//VARIABLES
var Fieldsize=4;  //4-, 6- or 8-Player Field [4,6,8]
var PlayerCount=1; //[0...Fieldsize]
var ComputerCount=1; //[0...Fieldsize-PlayerCount]
var TotalCount=0; 

//PROTOTYPES
void ThrowDice(var force);
void diceFunc();
void check_possibilites(var curPlayer);
void endae();

//PLAYERSTRUCT
typedef struct  { 
	var PinsOut;
	var StartNode;
	ENTITY* Pin[4];
} PlayerStruct;

PlayerStruct Player[8];
var currentPlayer=0;


//DICEDATA
ENTITY* dice;
var number;


STRING* PfadSTR = "";

////////////////////////////////////////////
//Check if a player has won:
//0: no win
//1: win
////////////////////////////////////////////
var check_win(var curPlayer)
{
	var i;
	for(i=0;i<4;i++)
	if(Player[curPlayer].Pin[i].STATUS!=2)
	return 0;
	return 1;
}


////////////////////////////////////////////
//Show winner screen
////////////////////////////////////////////
void show_win(curPlayer)
{
	proc_mode=PROC_NOFREEZE;
	freeze_mode=2;
	mouse_mode=0;
	
	STRING* Anzeige=str_create("");
	if(curPlayer>=PlayerCount)
	{
		str_cpy(Anzeige,"Computer ");
		str_cat(Anzeige,str_for_num(NULL,currentPlayer-PlayerCount));
	}
	else
	{
		str_cpy(Anzeige,"Player ");
		str_cat(Anzeige,str_for_num(NULL,currentPlayer));
	}
	str_cat(Anzeige," won!");
	while(!key_enter&&!key_space)
	{
		draw_quad(NULL,nullvector,NULL,vector(screen_size.x,screen_size.y,0),NULL,COLOR_BLACK,20,0);
		draw_text(_chr(Anzeige),screen_size.x/2-140,screen_size.y/2-20,COLOR_WHITE);
		draw_text("Press [Enter] to return to main menu.",screen_size.x/2-170,screen_size.y/2,COLOR_WHITE);
		draw_text("Press [Leertaste] to exit the game.",screen_size.x/2-165,screen_size.y/2+20,COLOR_WHITE);
		wait(1);
	}
	if(key_enter)
	{
		endae();
		freeze_mode=0;
		mouse_mode=4;
	}
	if(key_space)
	{
		sys_exit("");
	}
}



///////////////////////////////////////////////////////////////////////////////////////////////////
//Dice panel and stuff
///////////////////////////////////////////////////////////////////////////////////////////////////
void dicePANFunc();
var force=0;
var aforce=0;
BMAP* forceBarImgBMP = "bar.tga";
BMAP* forceBarBMP = "Hbar.tga";
BMAP* diceBMP = "dice.tga";
PANEL* forceBarPAN =
{
	bmap=forceBarImgBMP;
	window(0,200,64,0,forceBarBMP,0,200);
}
PANEL* dicePAN =
{
	button(0,200,diceBMP,diceBMP,diceBMP,dicePANFunc,NULL,NULL);
}
void dicePANFunc()
{
	var i;
	forceBarPAN.pos_x=screen_size.x-100;
	while(mouse_left)
	{
		pan_setwindow(forceBarPAN,1,0,clamp(200-2*force,0,200),64,clamp(2*force,0,200),forceBarBMP,0,aforce);
		if(i)
		{
			force=clamp(force+6*time_step,0,100);
			if(force>=100)
			i=0;
		}
		else
		{
			force=clamp(force-6*time_step,0,100);
			if(force<=0)
			i=1;
		}
		aforce=200;
		wait(1);
	}
	ThrowDice(force);
	force=0;
	pan_setwindow(forceBarPAN,1,0,clamp(200-2*force,0,200),64,clamp(2*force,0,200),forceBarBMP,0,aforce);
	reset(dicePAN,SHOW);
	reset(forceBarPAN,SHOW);
}
void diceFunc()
{
	set(dicePAN,SHOW);
	set(forceBarPAN,SHOW);
	dicePAN.pos_x=screen_size.x-128;
	forceBarPAN.pos_x=screen_size.x-100;
	while(is(dicePAN,SHOW))wait(1);
}




///////////////////////////////////////////////////////////////////////////////////////////////////
//Shows the current player
//Plays music
///////////////////////////////////////////////////////////////////////////////////////////////////
BMAP* mOnBMP = "mOn.tga";
BMAP* mOffBMP = "mOff.tga";
var MainMusic;
void MusikmToggle()
{
	if(snd_playing(MainMusic))
	snd_stop(MainMusic);
	else
	MainMusic=snd_loop(snd_create("Danger Storm.ogg"),100,0);
}
PANEL* MusicmPan =
{
	button_toggle(0,0,mOffBMP,mOnBMP,mOffBMP,mOnBMP,MusikmToggle,NULL,NULL);
}
void MusicAndStuff()
{
	MusicmPan.pos_y=screen_size.y-32;
	set(MusicmPan,SHOW);
	STRING* Anzeige=str_create("");
	while(1)
	{
		if(currentPlayer>=PlayerCount)
		{
			str_cpy(Anzeige,"Computer ");
			str_cat(Anzeige,str_for_num(NULL,currentPlayer-PlayerCount));
		}
		else
		{
			str_cpy(Anzeige,"Player ");
			str_cat(Anzeige,str_for_num(NULL,currentPlayer));
		}
		str_cat(Anzeige,"'s turn!");
		draw_text(Anzeige,10,10,COLOR_WHITE);
		wait(1);
	}
}


////////////////////////////////////////////
//Check for other player
//0: no Player/Computer
//1: own Player
////////////////////////////////////////////
var check_otherPlayer(var curPlayer, var node, var status)
{
	var i,j;
	if(status==2)
	{
		for(i=0;i<4;i++)
		if(node==Player[curPlayer].Pin[i].NODE&&Player[curPlayer].Pin[i].STATUS==2)
		return 1;
	}	
	else
	{
		for(i=0;i<TotalCount;i++)
		for(j=0;j<4;j++)
		if(node==Player[i].Pin[j].NODE&&Player[i].Pin[j].STATUS==1)
		{
			if(i!=curPlayer)
			return 0;
			else
			return 1;
		}
	}
	return 0;
}

//////////////////////////////////////////////////////////////////
//Check for possibilities
//1: possible move
//0: no possible move
//////////////////////////////////////////////////////////////////
var checkthrow_otherPlayer(var curPlayer, var node, var status)
{
	var i,j;
	if(status==2)
	{
		for(i=0;i<4;i++)
		if(node==Player[curPlayer].Pin[i].NODE&&Player[curPlayer].Pin[i].STATUS==2)
		return 1;
	}	
	else
	{
		for(i=0;i<TotalCount;i++)
		for(j=0;j<4;j++)
		if(node==Player[i].Pin[j].NODE&&Player[i].Pin[j].STATUS==1)
		{
			if(i!=curPlayer)
			{
				Player[i].PinsOut+=1;
				Player[i].Pin[j].STATUS=0;
				str_cpy(PfadSTR,"Path_00");
				str_cat(PfadSTR,str_for_num(NULL,i));
				path_set(Player[i].Pin[j],PfadSTR);
				Player[i].Pin[j].NODE=j+1;
				path_getnode(Player[i].Pin[j],Player[i].Pin[j].NODE,Player[i].Pin[j].x,NULL);
				return 0;
			}
			else
			return 1;
		}
	}
	return 0;
}

void actMarkierung()
{
	set(my,PASSABLE|UNLIT|LIGHT);
	vec_set(my.blue,COLOR_WHITE);
	my.skill1=currentPlayer;
	while(!dice&&!is(forceBarPAN,SHOW)&&my.skill1==currentPlayer)wait(1);
	ent_remove(me);
}

void actMarkierung2()
{
	set(my,PASSABLE|UNLIT|LIGHT);
	vec_set(my.blue,COLOR_RED);
	if(currentPlayer>=PlayerCount||useWaits)wait(-0.3);
	ent_remove(me);
}

//////////////////////////////////////////////////////////////////
//Check for possibilities and mark them
//////////////////////////////////////////////////////////////////
void check_possibilites(var curPlayer)
{
	var i;
	if(number==6)
	{
		if(Player[curPlayer].PinsOut>0)
		{
			if(check_otherPlayer(curPlayer,Player[curPlayer].StartNode,1)==0)
			{
				for(i=0;i<4;i++)
				if(Player[curPlayer].Pin[i].STATUS==0)
				ent_create("mark.mdl",Player[curPlayer].Pin[i].x,actMarkierung);
			}
		}
	}
	for(i=0;i<4;i++)
	{
		if(Player[curPlayer].Pin[i].STATUS==1)
		{
			if(Player[curPlayer].Pin[i].STEPS+number<Fieldsize*10+1)
			{
				if(check_otherPlayer(curPlayer, Player[curPlayer].Pin[i].NODE+number,1)==0)
				ent_create("mark.mdl",Player[curPlayer].Pin[i].x,actMarkierung);
			}
			else if(Player[curPlayer].Pin[i].STEPS+number<Fieldsize*10+5)
			{
				if(check_otherPlayer(curPlayer, -Fieldsize*10+Player[curPlayer].Pin[i].STEPS+number,2)==0)
				ent_create("mark.mdl",Player[curPlayer].Pin[i].x,actMarkierung);
			}
		}
		if(Player[curPlayer].Pin[i].STATUS==2)
		{
			if(Player[curPlayer].Pin[i].NODE+number<5)
			{
				if(check_otherPlayer(curPlayer, Player[curPlayer].Pin[i].NODE+number,2)==0)
				ent_create("mark.mdl",Player[curPlayer].Pin[i].x,actMarkierung);
			}
		}
	}	
}


//////////////////////////////////////////////////////////////////
//Check for possibilities
//1: possible move
//0: no possible move
//////////////////////////////////////////////////////////////////
var check_situation(var curPlayer)
{
	var i;
	if(number==6)
	{
		if(Player[curPlayer].PinsOut>0)
		{
			if(check_otherPlayer(curPlayer,Player[curPlayer].StartNode,1)==0)
			return 1;
		}
	}
	
	for(i=0;i<4;i++)
	{
		if(Player[curPlayer].Pin[i].STATUS==1)
		{
			if(Player[curPlayer].Pin[i].STEPS+number<Fieldsize*10+1)
			{
				if(check_otherPlayer(curPlayer, Player[curPlayer].Pin[i].NODE+number,1)==0)
				return 1;
			}
			else if(Player[curPlayer].Pin[i].STEPS+number<Fieldsize*10+5)
			{
				if(check_otherPlayer(curPlayer, -Fieldsize*10+Player[curPlayer].Pin[i].STEPS+number,2)==0)
				return 1;
			}
		}
		if(Player[curPlayer].Pin[i].STATUS==2)
		{
			if(Player[curPlayer].Pin[i].NODE+number<5)
			{
				if(check_otherPlayer(curPlayer, Player[curPlayer].Pin[i].NODE+number,2)==0)
				return 1;
			}
		}
	}
	return 0;
}


///////////////////////////////////////////////////////////////////////////////////////////////////
//Move a player
///////////////////////////////////////////////////////////////////////////////////////////////////
var choosemovePin(ENTITY* Pin, var curPlayer, var anzahlknoten)
{
	if(anzahlknoten==6&&Pin.STATUS==0)
	{
		if(checkthrow_otherPlayer(curPlayer, Player[curPlayer].StartNode,1)==0)
		{
			Pin.NODE=Player[curPlayer].StartNode;
			Pin.STEPS=1;
			path_set(Pin,"spielpfad");
			path_getnode(Pin,Pin.NODE,Pin.x,NULL);
			Player[curPlayer].PinsOut-=1;
			Pin.STATUS=1;
			return 1;
		}
	}
	else
	{
		if(Pin.STATUS==1)
		{
			if(Pin.STEPS+anzahlknoten < Fieldsize*10+1) //41
			{
				if(checkthrow_otherPlayer(curPlayer, cycle(Pin.NODE+anzahlknoten,1,Fieldsize*10+1),1)==0)
				{
					Pin.NODE+=anzahlknoten;
					Pin.NODE=cycle(Pin.NODE,1,Fieldsize*10+1);
					Pin.STEPS+=anzahlknoten;
					path_getnode(Pin,Pin.NODE,Pin.x,NULL);
					return 1;
				}
			}
			else if(Pin.STEPS+anzahlknoten < Fieldsize*10+5)
			{
				if(check_otherPlayer(curPlayer, -Fieldsize*10+Pin.STEPS+anzahlknoten,2)==0)
				{
					Pin.STATUS=2;
					str_cpy(PfadSTR,"rein_00");
					str_cat(PfadSTR,str_for_num(NULL,curPlayer));
					path_set(Pin,PfadSTR);
					Pin.NODE=-Fieldsize*10+Pin.STEPS;
				}
			}
		}
		if(Pin.STEPS+anzahlknoten<Fieldsize*10+5&&Pin.STATUS==2)
		{
			if(check_otherPlayer(curPlayer, Pin.NODE+anzahlknoten,2)==0)
			{
				Pin.NODE+=anzahlknoten;
				Pin.STEPS+=anzahlknoten;
				path_getnode(Pin,Pin.NODE,Pin.x,NULL);
				if(check_win(curPlayer))show_win(curPlayer);
				return 1;
			}
		}
	}
	return 0;
}

//////////////////////////////////////////////////////////////////
//get a possible entitiy to move
//////////////////////////////////////////////////////////////////
var getEntity(var curPlayer)
{
	var i;

	for(i=0;i<4;i++)
	{			
		if(curPlayer>=PlayerCount)
		{			if(number==6)
			{
				if(Player[curPlayer].Pin[i].STATUS==0)
				{
					if(check_otherPlayer(curPlayer,Player[curPlayer].StartNode,1)==0)
					return i;
				}
			}
			if(Player[curPlayer].Pin[i].STATUS==1)
			{
				if(Player[curPlayer].Pin[i].STEPS+number<Fieldsize*10+1)
				{
					if(check_otherPlayer(curPlayer, Player[curPlayer].Pin[i].NODE+number,1)==0)
					return i;
				}
				else if(Player[curPlayer].Pin[i].STEPS+number<Fieldsize*10+5)
				{
					if(check_otherPlayer(curPlayer, -Fieldsize*10+Player[curPlayer].Pin[i].STEPS+number,2)==0)
					return i;
				}
			}
			if(Player[curPlayer].Pin[i].STATUS==2)
			{
				if(Player[curPlayer].Pin[i].NODE+number<5)
				{
					if(check_otherPlayer(curPlayer, Player[curPlayer].Pin[i].NODE+number,2)==0)
					return i;
				}
			}
		}
		else
		{
			draw_text("Thrown: ",10,30,COLOR_WHITE);
			draw_text(str_for_num(NULL,number),100,30,COLOR_WHITE);
			if(mouse_left)
			if(mouse_ent)
			if(mouse_ent==Player[curPlayer].Pin[i])
			return i;
		}
	}
	return -1;
}

///////////////////////////////////////////////////////////////////////////////////////////////////
//Main Function for the game
///////////////////////////////////////////////////////////////////////////////////////////////////
void Phase1(var curPlayer, var maxtries)
{
	var tries=0;
	var mode=0;
	for(tries=0;tries<maxtries;tries++)
	{
		if(curPlayer>=PlayerCount)
		ThrowDice(random(100));
		else
		{
			diceFunc();
			wait_for(diceFunc);
		}
		wait_for(ThrowDice);
		if(check_situation(curPlayer)==0&&maxtries==1)return;
		check_possibilites(currentPlayer);
		if(curPlayer>=PlayerCount||useWaits)wait(-0.3);
		if(number!=6&&maxtries>1)continue;
		while(mode==0)
		{
			var a=getEntity(curPlayer);
			if(a!=-1)
			{
				ent_create("mark.mdl",Player[curPlayer].Pin[a].x,actMarkierung2);
				if(curPlayer>=PlayerCount||useWaits)wait(-0.3);
				mode=choosemovePin(Player[curPlayer].Pin[a],curPlayer,number);
			}
			wait(1);
		}
		if(curPlayer>=PlayerCount)wait(-0.3);
		if(number==6&&maxtries==1)
		Phase1(curPlayer,1);
		return;
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////
//The main loop decides whether you may throw once or 3 times
///////////////////////////////////////////////////////////////////////////////////////////////////
void MainLoop()
{
	while(1)
	{
		if(currentPlayer>=PlayerCount)
		wait(-0.6);
		
		if(Player[currentPlayer].PinsOut==4)
		{
			Phase1(currentPlayer,3);
			wait_for(Phase1);
		}
		if(Player[currentPlayer].PinsOut<4)
		{
			Phase1(currentPlayer,1);
			wait_for(Phase1);
		}
		currentPlayer++;
		if(currentPlayer==TotalCount)currentPlayer=0;
		wait(1);
	}
}



///////////////////////////////////////////////////////////////////////////////////////////////////
//initialite the field
///////////////////////////////////////////////////////////////////////////////////////////////////
void init_Field()
{
	STRING* levelstr=str_create("");
	str_cpy(levelstr,"Brett");
	str_cat(levelstr,str_for_num(NULL,Fieldsize));
	str_cat(levelstr,".wmb");
	level_load(levelstr);
	wait(3);
	var i,j;
	str_cpy(levelstr,"Pin");
	str_cat(levelstr,str_for_num(NULL,Fieldsize));
	str_cat(levelstr,".mdl");
	
	for(i=0;i<TotalCount;i++)
	{
		for(j=0;j<4;j++)
		{
			Player[i].Pin[j]=ent_create(levelstr,nullvector,NULL);
			str_cpy(PfadSTR,"Path_00");
			str_cat(PfadSTR,str_for_num(NULL,i));
			path_set(Player[i].Pin[j],PfadSTR);
			Player[i].Pin[j].NODE = j+1;
			path_getnode(Player[i].Pin[j],Player[i].Pin[j].NODE,Player[i].Pin[j].x,NULL);
			Player[i].Pin[j].skin=i+1;
			Player[i].Pin[j].STATUS=0;
		}
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////
//dice function/////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
void ThrowDice(var force)
{
	if(dice)ent_remove(dice);
	if(time_factor>1)
	{
		number=integer(1+random(6));
		return;
	}

	number=0;
	var time=0; 
	var geschwindigkeit=10; 
	
	VECTOR angularGeschwindigkeit;
	VECTOR relativePosition;
	
	dice=ent_create("dice.mdl",vector(0,0,50),NULL);
	vec_set(dice.pan,vector(random(360),random(360),random(360)));
	pXent_settype(dice, PH_RIGID, PH_BOX);
	pXent_setmass (dice, 0.5);
	pX_setgravity(vector(0,0,-18.81));
	
	pXent_addforcecentral(dice,vec_rotate(vector(0,force,force),camera.pan));
	pXent_addtorqueglobal(dice, vector(random(force),random(force),random(force)));

	while(1)
	{
		draw_text("Throwing dice...",10,30,COLOR_WHITE);
		pXent_getangvelocity(dice,angularGeschwindigkeit);
		geschwindigkeit=vec_length(angularGeschwindigkeit);	
		if(geschwindigkeit<4)
		{
			time+=time_step/16;
			if(time>0.5)
			break;	
		}
		else
		time=0;
		wait(1);
	}
	
	vec_set(relativePosition,vector(dice.x,dice.y,dice.z+50));
	vec_to_ent(relativePosition,dice);
	if(abs(relativePosition.z)>abs(relativePosition.x)&&abs(relativePosition.z)>abs(relativePosition.y))
	{
		if(relativePosition.z>0)
		number=1;
		else
		number=6;
	}
	if(abs(relativePosition.y)>abs(relativePosition.x)&&abs(relativePosition.y)>abs(relativePosition.z))
	{
		if(relativePosition.y>0)
		number=3;
		else
		number=4;
	}
	if(abs(relativePosition.x)>abs(relativePosition.y)&&abs(relativePosition.x)>abs(relativePosition.z))
	{
		if(relativePosition.x>0)
		number=5;
		else
		number=2;
	}	
	safe_remove(dice);
}


///////////////////////////////////////////////////////////////////////////////////////////////////
//The camera
///////////////////////////////////////////////////////////////////////////////////////////////////
var CameraGeschw=0;
void init_Camera()
{
	VECTOR diff;
	vec_set(camera.pan,vector(0,-55,0));
	while(1)
	{
		if(time_factor>1)
		{
			wait(1);
			continue;
		}
		vec_set(camera.x,vector(-200,0,250));
		accelerate(CameraGeschw,ang(-currentPlayer*(360/Fieldsize)-CameraGeschw-45)*0.5,0);
		camera.pan=CameraGeschw;
		vec_rotate(camera.x,vector(CameraGeschw,0,0));
		wait(1);
	}
}


///////////////////////////////////////////////////////////////////////////////////////////////////
//Debug Panel
///////////////////////////////////////////////////////////////////////////////////////////////////
void init_DebugPanel()
{
	var i,j;
	VECTOR v;
	while(1)
	{
		for(i=0;i<TotalCount;i++)
		{
			draw_text("Player",100,20+20*i,COLOR_WHITE);
			draw_text(str_for_num(NULL,i),160,20+20*i,COLOR_WHITE);
			draw_text(str_for_num(NULL,Player[i].PinsOut),190,20+20*i,COLOR_WHITE);
			
			for(j=0;j<4;j++)
			{
				vec_set(v,Player[i].Pin[j].x);
				if(vec_to_screen(v.x,camera)!=NULL)
				{
					draw_text(str_for_num(NULL,Player[i].Pin[j].NODE),v.x,v.y,COLOR_RED);
					draw_text(str_for_num(NULL,Player[i].Pin[j].STEPS),v.x,v.y+10,COLOR_RED);
					draw_text(str_for_num(NULL,Player[i].Pin[j].STATUS),v.x,v.y+20,COLOR_RED);
				}
			}
		}
		wait(1);
	}
}


///////////////////////////////////////////////////////////////////////////////////////////////////
//Main Menu
///////////////////////////////////////////////////////////////////////////////////////////////////
BMAP* radio_over="radiobutton_over.tga";
BMAP* radio_on="radiobutton_on.tga";
BMAP* radio_off="radiobutton_off.tga";
BMAP* okay="okay.tga";
BMAP* up="up.tga";
BMAP* down="down.tga";
PANEL* FieldPAN = {}
void Menu_okayFunc()
{
	reset(FieldPAN,SHOW);
	TotalCount=PlayerCount+ComputerCount;
	var i;
	for(i=0;i<Fieldsize;i++)
	{
		Player[i].PinsOut=4;
		Player[i].StartNode=2+10*i;
	}
}

void Menu_radioFunc(var cradio)
{
	if(cradio==1)
	Fieldsize=4;
	else if(cradio==2)
	Fieldsize=6;
	else if(cradio==3)
	Fieldsize=8;
}

///////////////////////////////////////////////////////////////////////////////////////////////////
//Calculate the Player/Computercount
///////////////////////////////////////////////////////////////////////////////////////////////////
void Menu_changeValue(var cbutton)
{
	if(cbutton==5&&PlayerCount<Fieldsize)
	{
		if(ComputerCount+PlayerCount==Fieldsize&&ComputerCount>0)ComputerCount--;
		PlayerCount++;
	}
	else if(cbutton==6&&PlayerCount>0)
	{
		PlayerCount--;
		if(PlayerCount==0&&ComputerCount==1||PlayerCount==1&&ComputerCount==0)ComputerCount++;
	}
	else if(cbutton==7&&ComputerCount<Fieldsize)
	{
		if(ComputerCount+PlayerCount==Fieldsize&&PlayerCount>0)PlayerCount--;
		ComputerCount++;
	}
	else if(cbutton==8&&ComputerCount>0)
	{
		ComputerCount--;
		if(ComputerCount==0&&PlayerCount==1||ComputerCount==1&&PlayerCount==0)PlayerCount++;
	}
}


///////////////////////////////////////////////////////////////////////////////////////////////////
//Initialize the Menu
///////////////////////////////////////////////////////////////////////////////////////////////////
void init_Menu()
{
	set(FieldPAN,SHOW);
	pan_setbutton(FieldPAN,0,4,100, 200, radio_on, radio_off, radio_over, radio_over, Menu_radioFunc, NULL, NULL);
	pan_setbutton(FieldPAN,0,4,100, 230, radio_on, radio_off, radio_over, radio_over, Menu_radioFunc, NULL, NULL);
	pan_setbutton(FieldPAN,0,4,100, 260, radio_on, radio_off, radio_over, radio_over, Menu_radioFunc, NULL, NULL);
	pan_setbutton(FieldPAN,0,0,screen_size.x/2-100, screen_size.y-200, okay, okay, okay, okay, Menu_okayFunc, NULL, NULL);
	pan_setstring(FieldPAN,0,130, 200,font_create("Arial#16"),str_create("4 Player Field"));
	pan_setstring(FieldPAN,0,130, 230,font_create("Arial#16"),str_create("6 Player Field"));
	pan_setstring(FieldPAN,0,130, 260,font_create("Arial#16"),str_create("8 Player Field"));
	button_state(FieldPAN,1,1);

	pan_setdigits(FieldPAN,0,screen_size.x/2, screen_size.y/2-100,"Player Count: %.0f",font_create("Arial#16"),1,PlayerCount);
	pan_setdigits(FieldPAN,0,screen_size.x/2-20, screen_size.y/2-40,"Computer Count: %.0f",font_create("Arial#16"),1,ComputerCount);
	
	pan_setbutton(FieldPAN,0,0,screen_size.x/2+100, screen_size.y/2-110, up, up, up, down, Menu_changeValue, NULL, NULL);
	pan_setbutton(FieldPAN,0,0,screen_size.x/2+100, screen_size.y/2-94, down, down, down, down, Menu_changeValue, NULL, NULL);

	pan_setbutton(FieldPAN,0,0,screen_size.x/2+100, screen_size.y/2-50, up, up, up, down, Menu_changeValue, NULL, NULL);
	pan_setbutton(FieldPAN,0,0,screen_size.x/2+100, screen_size.y/2-34, down, down, down, down, Menu_changeValue, NULL, NULL);

	pan_setbutton(FieldPAN,0,0,screen_size.x/2-100, screen_size.y-200, okay, okay, okay, okay, Menu_okayFunc, NULL, NULL);

	while(is(FieldPAN,SHOW))wait(1);
}




///////////////////////////////////////////////////////////////////////////////////////////////////
//The end handler
///////////////////////////////////////////////////////////////////////////////////////////////////
void endae()
{
	reset(dicePAN,SHOW);
	reset(forceBarPAN,SHOW);
	
	proc_kill(init_Camera);
	proc_kill(MainLoop);
	proc_kill(choosemovePin);
	proc_kill(ThrowDice);
	proc_kill(MusicAndStuff);
	proc_kill(Phase1);
	currentPlayer=0;
	level_load("");
	dice=NULL;
	set(FieldPAN,SHOW);
	while(is(FieldPAN,SHOW))wait(1);
	
	init_Field();
	wait_for(init_Field);
	init_Camera();
	
	if(showDebug)
	init_DebugPanel();
	
	MainLoop();
	MusicAndStuff();
}
PANEL* endPAN;
void ende()
{
	proc_mode=PROC_NOFREEZE;
	freeze_mode=2-freeze_mode;
	mouse_mode=4-2*freeze_mode;
	while(freeze_mode)
	{
		draw_quad(NULL,nullvector,NULL,vector(screen_size.x,screen_size.y,0),NULL,COLOR_BLACK,20,0);
		draw_text("PAUSE",screen_size.x/2-20,screen_size.y/2-20,COLOR_WHITE);
		draw_text("Press [Enter] to return to main menu.",screen_size.x/2-170,screen_size.y/2,COLOR_WHITE);
		draw_text("Press [Leertaste] to exit the game.",screen_size.x/2-165,screen_size.y/2+20,COLOR_WHITE);
		if(key_enter)
		{
			endae();
			freeze_mode=0;
			mouse_mode=4;
			return;
		}
		if(key_space)
		{
			sys_exit("");
		}
		wait(1);
	}
}



///////////////////////////////////////////////////////////////////////////////////////////////////
//main function
///////////////////////////////////////////////////////////////////////////////////////////////////
void main()
{
	fps_max=60;
	camera.arc=100;
	mouse_mode=4;
	physX_open();
	random_seed(0);
	
	mouse_map=bmap_create("maus.tga");
	video_window(NULL,NULL,0,"Pachisi 1.0 - Ali Yklet");
	vec_set(screen_color,COLOR_BLACK);
	vec_set(sky_color,COLOR_BLACK);
	
	init_Menu();
	wait_for(init_Menu);
	init_Field();
	wait_for(init_Field);
	init_Camera();
	
	MainMusic=snd_loop(snd_create("Danger Storm.ogg"),100,0);
	
	if(showDebug)
	init_DebugPanel();
	
	MainLoop();
	MusicAndStuff();
	on_esc=ende;
}